select
  an.numero
  , g1.descricao as grupo_atual
  , m.data as data_ultima_mastite
  , (current_date - m.data) as dias_apos_ult_mastite
  , coalesce(pa1.nome, pr1.nome) as produto_1
  , coalesce(pa2.nome, pr2.nome) as produto_2
  , coalesce(pa3.nome, pr3.nome) as produto_3
  , (case m.ad when 0 then '1 (Grumos)'
               when 1 then '2 (Glndula inchada)'
               when 2 then '3 (Sistmico)'
                else '' end) as ad
  , (case m.ae when 0 then '1 (Grumos)'
               when 1 then '2 (Glndula inchada)'
               when 2 then '3 (Sistmico)'
                else '' end) as ae
  , (case m.pd when 0 then '1 (Grumos)'
               when 1 then '2 (Glndula inchada)'
               when 2 then '3 (Sistmico)'
                else '' end) as pd
  , (case m.pe when 0 then '1 (Grumos)'
               when 1 then '2 (Glndula inchada)'
               when 2 then '3 (Sistmico)'
                else '' end) as pe
from
  animal an
  join mamite m on m.cdmamite =
    (select first 1 re.cdmamite from mamite re where re.cdanimal = an.cdanimal and
        ((re.ad in (0,1,2)) or (re.ae in (0,1,2)) or (re.pd in (0,1,2)) or (re.pe in (0,1,2))) order by re.data desc)
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = an.cdanimal and re.dtmovimentacao <= current_date order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  left join tratamentobase tb on tb.cdtratamentobase = m.cdtratamentobase
  left join principioativo pa1 on pa1.cdprincipioativo = tb.cdprincipioativo1
  left join principioativo pa2 on pa2.cdprincipioativo = tb.cdprincipioativo2
  left join principioativo pa3 on pa3.cdprincipioativo = tb.cdprincipioativo3
  left join produto pr1 on pr1.cdproduto = tb.cdproduto1
  left join produto pr2 on pr2.cdproduto = tb.cdproduto2
  left join produto pr3 on pr3.cdproduto = tb.cdproduto3
